"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createAction = function (type) {
    var creator = function (payload) { return ({ type: type, payload: payload }); };
    creator.matches = function (action) { return action.type === type; };
    creator.type = type;
    return creator;
};
// NOTE: don't use addOn if using redux-api-middleware as it is fussy and will reject the action
// use for custom api middleware
exports.createApiAction = function (type, options, addOn) {
    var pendingType = type + "_PENDING";
    var successType = type + "_SUCCESS";
    var failureType = type + "_FAILURE";
    var creator = function (payload) {
        var _a = typeof (options) === 'function' ? options(payload) : options, CALL_API = _a.CALL_API, method = _a.method, endpoint = _a.endpoint, credentials = _a.credentials, headers = _a.headers;
        return __assign((_b = {}, _b[CALL_API] = {
            endpoint: endpoint,
            method: method,
            types: [pendingType, successType, failureType],
            body: method === 'POST' || method === 'PUT' ? payload : undefined,
            credentials: credentials,
            headers: headers,
        }, _b), addOn);
        var _b;
    };
    creator.type = type;
    creator.matches = function (action) {
        return action.type === pendingType || action.type === successType || action.type === failureType;
    };
    creator.matchesPending =
        function (action) { return action.type === pendingType; };
    creator.matchesSuccess =
        function (action) { return action.type === successType; };
    creator.matchesFailure =
        function (action) { return action.type === failureType; };
    return creator;
};
